# 前端开发面试题 （题目列表页）

## <a name='html'>HTML</a>

- Doctype作用？严格模式与混杂模式如何区分？它们有何意义?

- HTML5 为什么只需要写 <!DOCTYPE HTML>？

- 行内元素有哪些？块级元素有哪些？ 空(void)元素有那些？

- 页面导入样式时，使用link和@import有什么区别？

- 介绍一下你对浏览器内核的理解？

- 常见的浏览器内核有哪些？

- html5有哪些新特性、移除了那些元素？如何处理HTML5新标签的浏览器兼容问题？如何区分 HTML 和 HTML5？

- 简述一下你对HTML语义化的理解？

- 请描述一下 cookies，sessionStorage 和 localStorage 的区别？

- iframe有那些缺点？

- Label的作用是什么？是怎么用的？（加 for 或 包裹）

- HTML5的form如何关闭自动完成功能？

- 如何实现浏览器内多个标签页之间的通信? (阿里)

- 页面可见性（Page Visibility API） 可以有哪些用途？

- 实现不使用 border 画出1px高的线，在不同浏览器的Quirksmode和CSSCompat模式下都能保持同一效果。

- 网页验证码是干嘛的，是为了解决什么安全问题？

- title与h1的区别、b与strong的区别、i与em的区别？


## <a name='css'>CSS</a>

- 介绍一下标准的CSS的盒子模型？

- CSS选择符有哪些？哪些属性可以继承？

- CSS优先级算法如何计算？

- CSS3新增伪类有那些？

- 如何居中div？如何居中一个浮动元素？如何让绝对定位的div居中？

- display有哪些值？说明他们的作用。

- position的值relative和absolute定位原点是？

- CSS3有哪些新特性？

- 请解释一下CSS3的Flexbox（弹性盒布局模型）,以及适用场景？

- 一个满屏 品 字布局 如何设计?

- li与li之间有看不见的空白间隔是什么原因引起的？有什么解决办法？

- 为什么要初始化CSS样式?

- absolute的containing block计算方式跟正常流有什么不同？

- 对BFC规范(块级格式化上下文：block formatting context)的理解？

- CSS权重优先级是如何计算的？

- 移动端的布局用过媒体查询吗？

- 使用 CSS 预处理器吗？喜欢那个？

- CSS优化、提高性能的方法有哪些？

- ::before 和 :after中双冒号和单冒号 有什么区别？解释一下这2个伪元素的作用。

- 如何修改chrome记住密码后自动填充表单的黄色背景 ？

- 如果需要手动写动画，你认为最小时间间隔是多久，为什么？（阿里）

- display:inline-block 什么时候会显示间隙？(携程)

- style标签写在body后与body前有什么区别？

- 什么是CSS 预处理器 / 后处理器？

## <a name='js'>JavaScript</a>

-  介绍JavaScript的基本数据类型。

-  说说写JavaScript的基本规范？

-  JavaScript原型，原型链 ? 有什么特点？

-  JavaScript有几种类型的值？（堆：原始数据类型和 栈：引用数据类型），你能画一下他们的内存图吗？

-  Javascript如何实现继承？

-  Javascript作用链域?

-  谈谈this对象的理解。

-  eval是做什么的？

-  什么是window对象? 什么是document对象?

-  null，undefined的区别？

-  ["1", "2", "3"].map(parseInt) 答案是多少？

-  什么是闭包（closure），为什么要用它？

-  javascript 代码中的"use strict";是什么意思 ? 使用它区别是什么？

-  如何判断一个对象是否属于某个类？

-  new操作符具体干了什么呢?

-  用原生JavaScript的实现过什么功能吗？

-  object.hasOwnProperty(proName)

-  对JSON的了解？

-  `[].forEach.call($$("*"),function(a){
  a.style.outline="1px solid #"+(~~(Math.random()*(1<<24))).toString(16)
})` 能解释一下这段代码的意思吗？

-  js延迟加载的方式有哪些？

-  Ajax 是什么? 如何创建一个Ajax？

-  同步和异步的区别?

-  如何解决跨域问题?

-  页面编码和被请求的资源编码如果不一致如何处理？

-  模块化开发怎么做？

-  谈一谈你对ECMAScript6的了解？

-  异步加载的方式有哪些？

-  DOM操作——怎样添加、移除、移动、复制、创建和查找节点?

-  .call() 和 .apply() 的作用和区别？

-  数组和对象有哪些原生方法，列举一下？

-  JS 怎么实现一个类。怎么实例化这个类

-  JavaScript中的作用域与变量声明提升？

-  如何编写高性能的Javascript？

-  那些操作会造成内存泄漏？

-  JQuery的源码看过吗？能不能简单概况一下它的实现原理？

-  jQuery.fn的init方法返回的this指的是什么对象？为什么要返回this？

-  jquery中如何将数组转化为json字符串，然后再转化回来？

-  jQuery 的属性拷贝(extend)的实现原理是什么，如何实现深拷贝？

-  jquery.extend 与 jquery.fn.extend的区别？

-  jQuery 的队列是如何实现的？队列可以用在哪些地方？

-  谈一下Jquery中的bind(),live(),delegate(),on()的区别？

-  JQuery一个对象可以同时绑定多个事件，这是如何实现的？

-  是否知道自定义事件。jQuery里的fire函数是什么意思，什么时候用？

-  jQuery 是通过哪个方法和 Sizzle 选择器结合的？（jQuery.fn.find()进入Sizzle）

-  针对 jQuery性能的优化方法？

-  Jquery与jQuery UI有啥区别？

-  JQuery的源码看过吗？能不能简单说一下它的实现原理？

-  jquery 中如何将数组转化为json字符串，然后再转化回来？

-  jQuery和Zepto的区别？各自的使用场景？

-  针对 jQuery 的优化方法？

-  Zepto的点透问题如何解决？

-  jQueryUI如何自定义组件?

-  需求：实现一个页面操作不会整页刷新的网站，并且能在浏览器前进、后退时正确响应。给出你的技术实现方案？

-  如何判断当前脚本运行在浏览器还是node环境中？（阿里）

-  移动端最小触控区域是多大？

-  jQuery 的 slideUp动画 ，如果目标元素是被外部事件驱动, 当鼠标快速地连续触发外部元素事件, 动画会滞后的反复执行，该如何处理呢?

-  把 Script 标签 放在页面的最底部的body封闭之前 和封闭之后有什么区别？浏览器会如何解析它们？

-  移动端的点击事件的有延迟，时间是多久，为什么会有？ 怎么解决这个延时？（click 有 300ms 延迟,为了实现safari的双击事件的设计，浏览器要知道你是不是要双击操作。）

-  知道各种JS框架(Angular, Backbone, Ember, React, Meteor, Knockout...)么? 能讲出他们各自的优点和缺点么?
-  Underscore 对哪些 JS 原生对象进行了扩展以及提供了哪些好用的函数方法？

-  解释JavaScript中的作用域与变量声明提升？

-  什么是“前端路由”?什么时候适合使用“前端路由”? “前端路由”有哪些优点和缺点?

-  知道什么是webkit么? 知道怎么用浏览器的各种工具来调试和debug代码么?

- 如何测试前端代码么? 知道BDD, TDD, Unit Test么? 知道怎么测试你的前端工程么(mocha, sinon, jasmin, qUnit..)?

- 前端templating(Mustache, underscore, handlebars)是干嘛的, 怎么用?

- What is a Polyfill? 

- 我们给一个dom同时绑定两个点击事件，一个用捕获，一个用冒泡。会执行几次事件，会先执行冒泡还是捕获？

- 请介绍一下JS之事件节流、防抖？

#### <a name='other'>ECMAScript6 相关</a>

- Object.is() 与原来的比较操作符“ ===”、“ ==”的区别？ 

- ES6是如何实现编译成ES5的？
